<?
/****************************************************************************
COMMON_FUNCTION
 + ist eine Funktionssammlung um für "vermisste" IPS-Funktionalitäten einen
   Workaround zu haben

    ... PARESY nicht böse sein :-) --> kannst die Funktionen gerne optimiert
        in den Kernel mitaufnehmen

    ... http://www.ip-symcon.de/forum/f53/ip-symcon-variablenzugriffe-ueber-namen-7231/

Release: 1.2
ReleaseDate: 06.01.2016

ReleaseNote:
02.04.2009 - R0.1 - Gusenbauer
 + erste Funktionen angelegt und getestet

01.05.2009 - R0.2 - Gusenbauer
 + der IPS-Gemeinde zur Verfügung gestellt

01.05.2009 - R0.3 - Gusenbauer
 + Allen Funktionen um die Möglichkeit gegeben mit relativen Pfad umzugehen zu koennen
   ... ein relativer Pfad beginnt mit "./"
 + neue Funktion GetValueByName

04.05.2009 - R0.3.1 - Gusenbauer
 + Alle IPS - Funktionen mit @Funktionsnamen aufgerufen,
   dass deren Debugmeldungen nicht mehr durchkommen
 + CheckCreateVariable geändert
 + Fuer SetValue*ByName eine globale interne Funktion _SetValueByName eingefuehrt

05.05.2009 - R0.3.2 - Gusenbauer
 + neue Funktionen (*CC = Check and Create)
          - SetValueBooleanByNameCC
          - SetValueIntegerByNameCC
          - SetValueFloatByNameCC
          - SetValueStringByNameCC
 + Funktion _SetValueByName erweitert um fehlende Hierachieebenen
   mit Kategorieelementen zu füllen und automatischer Variablenerstellung
   wenn CheckCreate = 1

15.05.2009 - R0.4 - Gusenbauer
 + Relativer Pfad erweitert um folgende Funktionalitaeten
     - /   ==> Ebene unterhalb des Scriptes
     - ./  ==> Ebene wie Script
     - ../ ==> Ebene oberhalb des Scriptes
 + neue Funktion GetVariableByName
 + Bereitstellung der IPS-Communitiy als R0.4

13.07.2009 - R0.5 - Gusenbauer
 + BUGFIX --> _SetValueByName --> bei relativen Pfad Variable "$PathString"
   initialisieren, hat zu "Warnings" in IPS2.1 Beta gefuehrt
   ==> wegen error_reporting=E_ALL
 + Bereitstellung der IPS-Communitiy als R0.5

31.07.2009 - R0.6 - Gusenbauer
 + BUGFIX in CheckCreateVariable ==> Warning in IPS2.1 Beta
 + Bereitstellung der IPS-Community als R0.6

09.09.2009 - R0.7 - Gusenbauer
 + GetValueFormattedByName ==> neue Funktion eingeführt
 + CheckScriptExistsByName ==> neue Funktion eingeführt
 + SetValue*ByNameCC um Parameter "VariablenProfil", "VariablenProfilActionScript" und "VariablenInfoText"
                     erweitert beim anlegen der Variable
                     (ein nachträgliches ändern einer existierenden Variable ist nicht möglich)
 + CheckCreateVariable ==> Erweitert wie SetValue*CC
 + Bereitstellung der IPS-Community als R0.7

07.11.2009 - R0.8b - Gusenbauer
 + Neue Functionen UUID / GUID (Globaly Unique IDentiffier)

21.04.2010 - R0.8.1b - Gusenbauer
 + IPS_SELF mit global uebergeben

11.01.2012 - R0.8.2b - Gusenbauer
 + global IPS_SELF jetzt auf $_IPS geaendert und eben mit $IPS['SELF'] abgefragt
   (soll ja zur IPS3.0 dann Standard werden und die Emulation wegfallen)

15.02.2015 - R0.9 - Gusenbauer
 + Wochenplanfunktion
   - GetWeekplanState

15.05.2015 - R1.0 - Gusenbauer
 + BUGFIX - GetWeekplanState --> Wochenplanfunktion,
      hatte Probleme mit Schaltpunkten um 00:00:00
 + BUGFIX - _SetValueByName,
      Variablenwert vor Zuweisung sicherheitshalber gewandelt
 + NEW - CheckIsHoliday eingefuehrt, prueft ob ein Feiertag in OESTERREICH !!
 + NEW - GetEasterOffset, berechnet den Ostersonntag bzw. den Offsettag
 + NEW - fill_left, fuellt String links auf
 + NEW - fill_rigth, fuellt string rechts auf
 + NEW - formated_comma , formatiert ein Zahl

02.01.2016 - R1.1 - Gusenbauer
 + BUGFIX - GetWeekplanState 
   --> Komplettumbau der Funktion wegen diverser Fehler mit Lücken (ID=0) 

06.01.2016 - R1.2 - Gusenbauer
 + BUGFIX - GetWeekplanState 
   --> Ausgeblendete Tage haben nicht funktioniert 

*****************************************************************************/

/****************************************************************************
fill_left,
  fuellt den string links mit Zeichen auf

Example: fill_left("12.3", " ", 7);

ReleaseNotes:
15.05.2015 tgusi74
 + Funktion erstellt
*****************************************************************************/
if (!function_exists('fill_left'))
{
 function fill_left($text="", $fillchar=" ", $length=1)
 {
  return str_pad($text,$length,$fillchar,STR_PAD_LEFT);
 }
}


/****************************************************************************
fill_right,
  fuellt den string links mit Zeichen auf

Example: fill_right("abc", " ", 7);

ReleaseNotes:
15.05.2015 tgusi74
 + Funktion erstellt
*****************************************************************************/
if (!function_exists('fill_right'))
   {
    function fill_right($text="", $fillchar=" ", $length=1)
      {
       return str_pad($text,$length,$fillchar,STR_PAD_RIGHT);
      }
   }


/****************************************************************************
formated_comma,
  formatiert eine Zahl

Example: formated_comma(123.123456, 2);

ReleaseNotes:
15.05.2015 tgusi74
 + Funktion erstellt
*****************************************************************************/
if (!function_exists('formated_comma'))
   {
    function formated_comma($zahl=0,$comma_digits=2)
     {
      return @number_format($zahl,$comma_digits,'.','');
     } 
   }


/****************************************************************************
GetWeekplanState,
  liest den Zustand eines gewünschten Wochenplanereignisses aus

  GetWeekplanStateGetWeekplanState(WochenplanID,[Abfragezeitpunkt_als_Systemzeit])
  
Example: $Zustand = GetWeekplanState(1234);
         oder
         $Zustand = GetWeekplanStateGetWeekplanState(1234,time()-24*3600)
    
[ActionID] => 4                          ==> Aktiver Zustand zum Abfragezeitpunkt
[ActionName] => FREI                     ==> Zustandsbezeichnung zum Abfragezeitpunkt
[CheckSysTime] => 1423986592             ==> Zeitpunkt fuer den die Ueberprufung gestartet wurde
[CheckTime] => 15.02.2015 08:49:52       ==> Formatierter Ueberpruefungszeitpunkt
[StartSysTime] => 1423861200             ==> Schaltpunkt wo der AKTIVE ZUSTAND aktiv wurde
[StartTime] => 13.02.2015 22:00:00       ==> Formatierter Startpunkt
[EndSysTime] => 1424034000               ==> Schaltpunkt wo der AKTIVE ZUSTAND verlassen wird
[EndTime] => 15.02.2015 22:00:00         ==> Formatierter Endpunkt
[Periode] => 172800                      ==> Zeitdauer des aktiven Zustand ins Sekunden
[PeriodeHours] => 48                     ==> Formatierte Zeitdauer STUNDEN
[PeriodeMinutes] => 0                    ==> Formatierte Zeitdauer MINUTEN
[PeriodeSeconds] => 0                    ==> Formatierte Zeitdauer SEKUNDEN
[PreviousActionID] => 2                  ==> Zustand der VOR dem aktuellen Zustand
[PreviousActionName] => 2-Mittelschicht  ==> Zustandsbezeichung vorherigen Zustand
[NextActionID] => 3                      ==> Zustand der den aktuellen Zustand beloest wird
[NextActionName] => 3-Nachtschicht       ==> Zustandsbezeichung zukuenftiges Zustandes
[WeekPlanID] => 15405                    ==> ID des Wochenplans
[WeekPlanName] => SCHICHTPLANTEST        ==> Name des Wochenplans
[WeekPlanActiv] => 1                     ==> Zustand ob der Wochenplan aktiv ist oder nicht 
    
ReleaseNotes:
15.02.2015 tgusi74
 + Function erstellt und geprüft
14.05.2015 tgusi74 #1
 + Fehler beseitigt mit Schaltpunkt um 00:00:00 am aktuellen Tag
15.05.2015 tgusi74 #2
 + Fehler beseitigt mit Schaltpunkt um 00:00:00 am Folgetag
28.12.2015 tgusi74 #3
 + Variablen frueher initialisiert
 + Wenn kein Tagesevent vorhanden, dann default 0
31.12.2015 tgusi74 #4
 + Diverse Aenderungen wegen ID=0 im Wochenplan
 + WeekPlanName, WeekPlanID, WeekPlanName hinzugefuegt
02.01.2016 tgusi74 #5
 + Komplettumbau der Funktion wegen diverser Fehler mit ID=0
06.01.2015 tgusi74 #6
 + Ausgeblendete Tage (Luecken) haben nicht funktioniert, 
   daher jetzt gesondert geprueft ==> DayFound
*****************************************************************************/
if (!function_exists('GetWeekplanState'))
{
function GetWeekplanState($ID, $SysTimePoint=NULL, $CheckOnlySlot=false)
 {
   if($SysTimePoint == NULL)
     {
      $SysTimePoint = time();
     }

   $State = array();
   $State['ActionID']           = 0;
   $State['ActionName']         = "";
   $State['CheckSysTime']       = $SysTimePoint;
   $State['CheckTime']          = "01.01.1970 00:00:00";
   $State['StartSysTime']       = $SysTimePoint-86400*7;
   $State['StartTime']          = "01.01.1970 00:00:00";
   $State['EndSysTime']         = $SysTimePoint+86400*7;
   $State['EndTime']            = "01.01.1970 00:00:00";
   $State['Periode']            = 0;
   $State['PeriodeHours']       = 0;
   $State['PeriodeMinutes']     = 0;
   $State['PeriodeSeconds']     = 0;
   $State['PreviousActionID']   = 0;
   $State['PreviousActionName'] = "";
   $State['NextActionID']       = 0;
   $State['NextActionName']     = "";
   $State['WeekPlanID']         = $ID;
   $State['WeekPlanName']       = IPS_GetName($ID);
   $State['WeekPlanActiv']      = 0;

   $e = IPS_GetEvent($ID);
   if ($e['EventType'] != 2)
      {
       echo ("Bei der ID= " . $ID . " handelt es sich um keinen Wochenplan !! ==> ABBRUCH !!" . "\r\n");
       return($State);
      }

   if ($e['EventActive'] == 1)
      {
       //#4 - Aktivstatus mitausgeben
       $State['WeekPlanActiv'] = 1;
      }

   //#3 Variablen vorinitialisieren
   $StartPointFound = false;
   $EndPointFound   = false;
   $DayEventFound   = false;
   $DayFound        = false;

   //Durch alle Gruppen gehen
   foreach($e['ScheduleGroups'] as $g)
     {
      //pruefen ob Gruppe fuer Zeitpunkt zustaendig
      if(($g['Days'] & pow(2,date("N",$SysTimePoint)-1)) > 0)
        {
         $DayFound        = true;
         $StartPointFound = false;
         $ActualSlotFound = false;
         $EndPointFound   = false;
         $State['StartSysTime'] = mktime(0,0,0,date("m",$SysTimePoint),date("d",$SysTimePoint),date("Y",$SysTimePoint));
         $SearchTimeActDay      = date("H",$SysTimePoint) * 3600 + date("i",$SysTimePoint) * 60 + date("s",$SysTimePoint);

         //Aktuellen Schaltpunkt suchen --> Wir nutzen die Eigenschaft, dass die Schaltpunkte immer aufsteigend sortiert sind.
         foreach($g['Points'] as $p)
           {
            $StartTimeActDaySlot  = $p['Start']['Hour'] * 3600 + $p['Start']['Minute'] * 60 + $p['Start']['Second'];
            $DayEventFound = true;

            if($SearchTimeActDay >= $StartTimeActDaySlot)
              {
               if($ActualSlotFound == false)
                 {
                  $ActualSlotFound = true;
                  $State['ActionID']     = $p['ActionID'];
                  $State['StartSysTime'] = mktime($p['Start']['Hour'],$p['Start']['Minute'],$p['Start']['Second'],date("m",$SysTimePoint),date("d",$SysTimePoint),date("Y",$SysTimePoint));
                 }
               else
                 {
                  $StartPointFound = true;
                  $State['PreviousActionID']  = $State['ActionID'];
                  $State['ActionID']          = $p['ActionID'];
                  $State['StartSysTime'] = mktime($p['Start']['Hour'],$p['Start']['Minute'],$p['Start']['Second'],date("m",$SysTimePoint),date("d",$SysTimePoint),date("Y",$SysTimePoint));
                 }
              }
            else
              {
               if($EndPointFound == false)
                 {
                  $EndPointFound   = true;
                  $State['NextActionID']     = $p['ActionID'];
                  $State['EndSysTime'] = mktime($p['Start']['Hour'],$p['Start']['Minute'],$p['Start']['Second'],date("m",$SysTimePoint),date("d",$SysTimePoint),date("Y",$SysTimePoint));
                 }
               else
                 {
                  break;
                 }
              }
           }
         break; //Sobald wir unseren Tag gefunden haben, können wir die Schleife abbrechen.
                //Jeder Tag darf nur in genau einer Gruppe sein.
        }
     }

     //wenn kein Tag gefunden wird ==> Tag ist ausgeblendet !!
     if($DayFound == false)
       {
        if($CheckOnlySlot == false)
          {
           for($i=0;$i<=7;$i++)
              {
               foreach($e['ScheduleGroups'] as $g)
                  {
                   //pruefen ob Gruppe fuer Zeitpunkt zustaendig
                   if(($g['Days'] & pow(2,date("N",$SysTimePoint)-1-$i)) > 0)
                     {
                      $DayFound=true;
                      break 2;
                     }
                  }
              }

           $State['StartSysTime'] = mktime(00,00,00,date("m",$SysTimePoint),date("d",$SysTimePoint)+1-$i,date("Y",$SysTimePoint));
          }

        for($i=0;$i<=6;$i++)
           {
            foreach($e['ScheduleGroups'] as $g)
               {
                //pruefen ob Gruppe fuer Zeitpunkt zustaendig
                if(($g['Days'] & pow(2,date("N",$SysTimePoint)-1+$i)) > 0)
                  {
                   $DayFound=true;
                   break 2;
                  }
               }
           }

        if($State['StartSysTime'] <= $SysTimePoint) 
          {
           $State['StartSysTime']=$SysTimePoint;
          }

        $State['CheckSysTime']   = mktime(00,00,00,date("m",$SysTimePoint),date("d",$SysTimePoint)-1+$i,date("Y",$SysTimePoint));
        $State['EndSysTime']     = mktime(00,00,00,date("m",$SysTimePoint),date("d",$SysTimePoint)-1+$i,date("Y",$SysTimePoint));
        $EndPointFound = false;
       }

  if($CheckOnlySlot == false)
    {

     //Startpunkt wurde zwar gefunden aber die ActionID ist 0 --> vorigen Schaltpunkt suchen
     if( ($StartPointFound == true) && ($State['ActionID'] == 0) )
       {
        do{
           $prevevent1 = GetWeekplanState($ID, $State['StartSysTime']-1 ,true);

           $State['StartSysTime']     = $prevevent1['StartSysTime'];
           $State['PreviousActionID'] = $prevevent1['ActionID'];

           if ( ($State['ActionID'] == 0) && ($prevevent1['ActionID'] != 0) )
              {
               $State['StartSysTime']     = $prevevent1['StartSysTime'];
               $State['ActionID']         = $prevevent1['ActionID'];
               $State['PreviousActionID'] = $prevevent1['PreviousActionID'];
               $DayEventFound = true;
              }
          } while(  ($State['ActionID'] == 0) && ($prevevent1['StartSysTime'] >= ($State['CheckSysTime']-86400*7)) );

        //Jetzt auch nochmals checken ob sich nicht auch der vorherige zu 0 veraendert hat
        if($State['PreviousActionID'] == 0)
          {
           $CheckTime1 = $State['StartSysTime'];

           do{
              $prevevent1 = GetWeekplanState($ID, $CheckTime1-1 ,true);

              $CheckTime1  = $prevevent1['StartSysTime'];

              if( ($State['PreviousActionID'] == 0) && ($prevevent1['ActionID'] != 0) )
                {
                 $State['PreviousActionID'] = $prevevent1['ActionID'];
                 $DayEventFound = true;
                }
             } while(  ($State['PreviousActionID'] == 0) && ($prevevent1['StartSysTime'] >= ($State['CheckSysTime']-86400*14)) ); //hier geht auch 7

           }
    }

    //Startpunkt liegt an einen der Vortage !!
    if($StartPointFound == false)
      {
       do{
          $prevevent1 = GetWeekplanState($ID, $State['StartSysTime']-1 ,true);

          if ( ($prevevent1['ActionID'] == 0) && ($prevevent1['PreviousActionID'] == 0) && ($prevevent1['NextActionID'] == 0) )
             {
              $State['StartSysTime'] = mktime(00,00,00,date("m",$prevevent1['StartSysTime']),date("d",$prevevent1['StartSysTime']),date("Y",$prevevent1['StartSysTime']));
             }
          elseif ( ($prevevent1['NextActionID'] == 0) && ($prevevent1['PreviousActionID'] == 0) && ($State['ActionID'] == $prevevent1['ActionID']) )
             {
              $State['StartSysTime'] = mktime(00,00,00,date("m",$prevevent1['StartSysTime']),date("d",$prevevent1['StartSysTime']),date("Y",$prevevent1['StartSysTime']));
             }
          else
             {
              $State['StartSysTime']     = $prevevent1['StartSysTime'];
              $State['PreviousActionID'] = $prevevent1['ActionID'];

              if( ($State['ActionID'] == 0) && ($prevevent1['ActionID'] != 0) )
                {
                 $State['StartSysTime']     = $prevevent1['EndSysTime']; //??
                 $State['ActionID']         = $prevevent1['ActionID'];
                 $State['PreviousActionID'] = $prevevent1['PreviousActionID'];
                 if($prevevent1['NextActionID'] == 0)
                   {
                    $State['StartSysTime'] = $prevevent1['StartSysTime'];
                   }

                 $DayEventFound = true;
                }
             }
          } while( ( ($State['ActionID'] == 0) || ($State['ActionID'] == $prevevent1['PreviousActionID']) )&& ($prevevent1['StartSysTime'] >= ($State['CheckSysTime']-86400*14)) );


          //Checken ob nicht doch der vorherige Schaltpunkt jetzt 0 ist
          if($State['PreviousActionID'] == 0)
            {
             $CheckTime1 = $State['StartSysTime'];

             do{
                $prevevent1 = GetWeekplanState($ID, $CheckTime1-1 ,true);
                if ( ($prevevent1['ActionID'] == 0) && ($prevevent1['PreviousActionID'] == 0) && ($prevevent1['NextActionID'] == 0) )
                   {
                    $CheckTime1 = mktime(00,00,00,date("m",$prevevent1['StartSysTime']),date("d",$prevevent1['StartSysTime']),date("Y",$prevevent1['StartSysTime']));
                   }
                else
                   {
                    $CheckTime1  = $prevevent1['StartSysTime'];
                   }

                if ( ($State['PreviousActionID'] == 0) && ($prevevent1['ActionID'] != 0) )
                   {
                    $State['PreviousActionID'] = $prevevent1['ActionID'];
                    $DayEventFound = true;
                   }
               } while(  ($State['PreviousActionID'] == 0) && ($prevevent1['StartSysTime'] >= ($State['CheckSysTime']-86400*14)) );
            }
      }

    //Vorheriger Schaltpunkt hat selben Status wie ActionID --> somit vorherigen Schaltpunkt fuer VORGAENGER suchen
    if ($State['ActionID'] == $State['PreviousActionID'])
       {
        $CheckTime1 = $State['StartSysTime'];

        do{
           $prevevent1 = GetWeekplanState($ID, $CheckTime1-1 ,true);

           if( ($prevevent1['ActionID'] == 0) && ($prevevent1['PreviousActionID'] == 0) && ($prevevent1['NextActionID'] == 0) )
             {
              $CheckTime1 = mktime(00,00,00,date("m",$prevevent1['StartSysTime']),date("d",$prevevent1['StartSysTime']),date("Y",$prevevent1['StartSysTime']));
             }
           elseif( ($prevevent1['NextActionID'] == 0) && ($prevevent1['PreviousActionID'] == 0) )
             {
              $CheckTime1 = mktime(00,00,00,date("m",$prevevent1['StartSysTime']),date("d",$prevevent1['StartSysTime']),date("Y",$prevevent1['StartSysTime']));
             }
           else
             {
              $CheckTime1 = $prevevent1['StartSysTime'];

              if( ($State['PreviousActionID'] != $prevevent1['ActionID']) && ($prevevent1['ActionID'] != 0) )
                {
                 $State['PreviousActionID'] = $prevevent1['ActionID'];
                 $State['StartSysTime']     = $prevevent1['EndSysTime'];
                 $DayEventFound = true;
                }
             }
           } while(  ($State['PreviousActionID'] == $State['ActionID']) && ($prevevent1['StartSysTime'] >= ($State['CheckSysTime']-86400*7)) );
       }


    //Endpunkt wurde zwar gefunden aber der naechste Schaltpunkt ist 0
    if( ($EndPointFound==true) && ($State['NextActionID'] == 0) )
      {
       $CheckTime1 = $State['EndSysTime'];

       do{
          $nextevent1 = GetWeekplanState($ID, $CheckTime1,true);

          if( ($nextevent1['ActionID'] == 0) && ($nextevent1['PreviousActionID'] == 0) && ($nextevent1['NextActionID'] == 0) )
            {
             $CheckTime1 = mktime(0,0,0,date("m",$nextevent1['StartSysTime']),date("d",$nextevent1['StartSysTime'])+1,date("Y",$nextevent1['StartSysTime']));
            }
         elseif( ($nextevent1['NextActionID'] == 0) && ($nextevent1['PreviousActionID'] == 0) )
            {
             $CheckTime1 = mktime(0,0,0,date("m",$nextevent1['StartSysTime']),date("d",$nextevent1['StartSysTime'])+1,date("Y",$nextevent1['StartSysTime']));
            }
         else
            {
             $CheckTime1 = $nextevent1['EndSysTime'];

             if( ($State['NextActionID'] != $nextevent1['ActionID']) || ($nextevent1['ActionID'] != 0) )
               {
                $State['NextActionID']  = $nextevent1['ActionID'];
                $State['EndSysTime']    = $nextevent1['StartSysTime'];
                $DayEventFound = true;
               }
            }
         } while( ($State['NextActionID'] == 0) && ($State['EndSysTime'] <= ($State['CheckSysTime']+86400*7)) );
      }



    //Endpunkt liegt an einen der Folgetage !!
    if($EndPointFound==false)
      {
       if(($State['StartSysTime']+86400*6) < $State['CheckSysTime'])
         {
          $State['CheckSysTime'] = ($State['StartSysTime']+86400*6);
         }

       $State['EndSysTime'] = mktime(0,0,0,date("m",$State['CheckSysTime']),date("d",$State['CheckSysTime'])+1,date("Y",$State['CheckSysTime']));

       do{
          $nextevent1 = GetWeekplanState($ID, $State['EndSysTime'],true);

          if( ($nextevent1['ActionID'] == 0) && ($nextevent1['PreviousActionID'] == 0) && ($nextevent1['NextActionID'] == 0) )
            {
             $State['EndSysTime'] = mktime(0,0,0,date("m",$nextevent1['StartSysTime']),date("d",$nextevent1['StartSysTime'])+1,date("Y",$nextevent1['StartSysTime']));
            }
          elseif( ($nextevent1['NextActionID'] == 0) && ($nextevent1['PreviousActionID'] == 0) )
            {
             $State['EndSysTime'] = mktime(0,0,0,date("m",$nextevent1['StartSysTime']),date("d",$nextevent1['StartSysTime'])+1,date("Y",$nextevent1['StartSysTime']));
            }
          else
            {
             $State['EndSysTime']   = $nextevent1['StartSysTime'];
             $State['NextActionID'] = $nextevent1['ActionID'];

             if( ($State['NextActionID'] == 0) || ($State['ActionID'] == $nextevent1['ActionID']) )
               {
                $State['EndSysTime']     = $nextevent1['EndSysTime'];
                $DayEventFound = true;
               }
            }
          } while( ( ($State['ActionID'] == $nextevent1['ActionID']) || ($State['NextActionID']  == $nextevent1['NextActionID']) )&& ($State['EndSysTime'] <= ($State['CheckSysTime']+86400*7)) );


       //Wenn es kein Abloesezeitpunkt (nur ein Event im Wochenplan) gibt !!
       if( ($State['EndSysTime'] >= ($State['CheckSysTime']+86400*7)) && ($State['NextActionID']== 0) )
         {
          $State['NextActionID'] = $State['ActionID'];
         }


       //Wenn naechster Schaltpunkt = 0 ist --> Folgeevent suchen !!
       if( ($State['NextActionID'] == 0) && ($State['ActionID'] != 0) && ($State['PreviousActionID'] != 0) )
         {
          $CheckTime1 = mktime(0,0,0,date("m",$State['CheckSysTime']),date("d",$State['CheckSysTime'])+1,date("Y",$State['CheckSysTime']));

          do{
             $nextevent1 = GetWeekplanState($ID, $CheckTime1,true);

             if( ($nextevent1['ActionID'] == 0) && ($nextevent1['PreviousActionID'] == 0) && ($nextevent1['NextActionID'] == 0) )
               {
                $CheckTime1 = mktime(0,0,0,date("m",$nextevent1['StartSysTime']),date("d",$nextevent1['StartSysTime'])+1,date("Y",$nextevent1['StartSysTime']));
               }
             elseif( ($nextevent1['NextActionID'] == 0) && ($nextevent1['PreviousActionID'] == 0) )
               {
                $CheckTime1 = mktime(0,0,0,date("m",$nextevent1['StartSysTime']),date("d",$nextevent1['StartSysTime'])+1,date("Y",$nextevent1['StartSysTime']));
               }
             else
               {
                $CheckTime1     = $nextevent1['EndSysTime'];

                if( ($State['NextActionID'] != $nextevent1['ActionID']) || ($nextevent1['ActionID'] != 0) )
                  {
                   $State['NextActionID']  = $nextevent1['ActionID'];
                   $State['EndSysTime']    = $nextevent1['StartSysTime'];
                   $DayEventFound = true;
                  }
               }
            } while( ($State['NextActionID'] == 0) && ($State['EndSysTime'] <= ($State['CheckSysTime']+86400*7)) );
         }


       //Wenn alle 3 Schaltpunkte gleich sind, dann Ueberpruefungszeitpunkt zurueckliefern (Kein oder nur EIN Event im Wochenplan)
       if( ($State['ActionID'] == $State['PreviousActionID']) && ($State['ActionID'] == $State['NextActionID']) )
         {
          $State['StartSysTime'] = $SysTimePoint;
          $State['EndSysTime']   = $SysTimePoint;
         }


      }
    }



  $State['CheckSysTime']   = $SysTimePoint;
  $State['CheckTime']      = date("d.m.Y H:i:s",$State['CheckSysTime']);
  $State['StartTime']      = date("d.m.Y H:i:s",$State['StartSysTime']);
  $State['EndTime']        = date("d.m.Y H:i:s",$State['EndSysTime']);

  $State['Periode']        = $State['EndSysTime'] - $State['StartSysTime'];
  $State['PeriodeHours']   = floor($State['Periode'] / 3600);
  $State['PeriodeMinutes'] = $State['Periode']       / 60   % 60;
  $State['PeriodeSeconds'] = $State['Periode']              % 60;

  foreach($e['ScheduleActions'] as $n)
    {
     if ($n['ID'] == $State['ActionID'])
        {
         $State['ActionName'] = $n['Name'];
        }

     if($n['ID'] == $State['PreviousActionID'])
       {
        $State['PreviousActionName'] = $n['Name'];
       }

     if($n['ID'] == $State['NextActionID'])
       {
        $State['NextActionName'] = $n['Name'];
       }
    }

   return($State);
 }

}


/****************************************************************************
CheckIsHoliday,
  prueft ob heute eine Feiertag ist
  
Example: if (CheckIsHoliday() == true)
            {
             print("JA HEUTE IST EIN FEIERTAG");
            }

ReleaseNotes:
15.05.2015 tgusi74
 + Funktion von JAVA-Script des DATE-TIME-PICKER uebernommen und angepasst
*****************************************************************************/
if (!function_exists('CheckIsHoliday'))
{
 function CheckIsHoliday($SysTimePoint=NULL)
 {
  if($SysTimePoint == NULL)
    {
     $SysTimePoint = time();
    }

  $ActDay   = date("j",$SysTimePoint);
  $ActMonth = date("n",$SysTimePoint);
  $Holiday = false;

  //Variable Feiertage
  $Aschermittwoch       = GetEasterOffset(date("Y",$SysTimePoint),-46);
  $Palmsonntag          = GetEasterOffset(date("Y",$SysTimePoint), -7);
  $Karfreitag           = GetEasterOffset(date("Y",$SysTimePoint), -2);
  $Ostersonntag         = GetEasterOffset(date("Y",$SysTimePoint),  0);
  $Ostermontag          = GetEasterOffset(date("Y",$SysTimePoint),  1);
  $Christihimmelfahrt   = GetEasterOffset(date("Y",$SysTimePoint), 39);
  $Pfingstsonntag       = GetEasterOffset(date("Y",$SysTimePoint), 49);
  $Pfingstmontag        = GetEasterOffset(date("Y",$SysTimePoint), 50);
  $Fronleihnam          = GetEasterOffset(date("Y",$SysTimePoint), 60);
  if ( ($ActDay == $Palmsonntag['Day'])        && ($ActMonth == $Palmsonntag['Month']) )          $Holiday = true;
  if ( ($ActDay == $Ostersonntag['Day'])       && ($ActMonth == $Ostersonntag['Month']) )         $Holiday = true;
  if ( ($ActDay == $Ostermontag['Day'])        && ($ActMonth == $Ostermontag['Month']) )          $Holiday = true;
  if ( ($ActDay == $Christihimmelfahrt['Day']) && ($ActMonth == $Christihimmelfahrt['Month']) )   $Holiday = true;
  if ( ($ActDay == $Pfingstsonntag['Day'])     && ($ActMonth == $Pfingstsonntag['Month']) )       $Holiday = true;
  if ( ($ActDay == $Pfingstmontag['Day'])      && ($ActMonth == $Pfingstmontag['Month']) )        $Holiday = true;
  if ( ($ActDay == $Fronleihnam['Day'])        && ($ActMonth == $Fronleihnam['Month']) )          $Holiday = true;

  //Fixe Feiertage --> OESTERREICH
  if ( ($ActDay ==  1) && ($ActMonth ==  1) ) $Holiday = true;
  if ( ($ActDay ==  6) && ($ActMonth ==  1) ) $Holiday = true;
  if ( ($ActDay ==  1) && ($ActMonth ==  5) ) $Holiday = true;
  if ( ($ActDay == 15) && ($ActMonth ==  8) ) $Holiday = true;
  if ( ($ActDay == 26) && ($ActMonth == 10) ) $Holiday = true;
  if ( ($ActDay ==  1) && ($ActMonth == 11) ) $Holiday = true;
  if ( ($ActDay ==  8) && ($ActMonth == 12) ) $Holiday = true;
  if ( ($ActDay == 24) && ($ActMonth == 12) ) $Holiday = true;
  if ( ($ActDay == 25) && ($ActMonth == 12) ) $Holiday = true;
  if ( ($ActDay == 26) && ($ActMonth == 12) ) $Holiday = true;
  if ( ($ActDay == 31) && ($ActMonth == 12) ) $Holiday = true;

  return ($Holiday);
 }
}


/****************************************************************************
GetEasterOffset,
  berechnet das Datum aufgrund des Offsets zum Ostersonntag

  ==> Ostern ist seit dem Jahr 325 als der erste Sonntag nach dem ersten Vollmond
      des Frühlings definiert.

  ==> Carl Friedrich Gauss hat 1800 eine Osterformel entwickelt,
      die die Hinzuziehung von astronomischen Tafeln überflüssig macht

  ==> Wichtige Feiertage:
      $Aschermittwoch       = getEasterOffset(date("Y"),-46);
      $Palmsonntag          = getEasterOffset(date("Y"),-7);
      $Karfreitag           = getEasterOffset(date("Y"),-2);
      $Ostersonntag         = getEasterOffset(date("Y"),0);
      $Ostermontag          = getEasterOffset(date("Y"),1);
      $Christihimmelfahrt   = getEasterOffset(date("Y"),39);
      $Pfingstsonntag       = getEasterOffset(date("Y"),49);
      $Pfingstmontag        = getEasterOffset(date("Y"),50);
      $Fronleihnam          = getEasterOffset(date("Y"),60);


GetEasterOffset([JAHRESZAHL FUER WELCHES JAHR BERECHNET WERDEN SOLL],[OFFSET ZUM OSTERSONNTAG]);

Example: $datum = GetEasterOffset(2015,39);

[Day] => 14               ==> Tag
[Month] => 5              ==> Monat
[Year] => 2015            ==> Jahr


ReleaseNotes:
14.05.2015 tgusi74
 + Funktion von JAVA-Script des DATE-TIME-PICKER uebernommen
*****************************************************************************/
if (!function_exists('GetEasterOffset'))
{
 function GetEasterOffset($Year, $OffsetDays)
 {
  $OffsetDate = array();
  $OffsetDate['Day']   = 1;
  $OffsetDate['Month'] = 1;
  $OffsetDate['Year']  = 1970;

  $a=$Year%19;
  $b=floor($Year/100);
  $c=$Year%100;
  $d=floor($b/4);
  $e=$b%4;
  $f=floor(($b+8)/25);
  $g=floor(($b-$f+1)/3);
  $h=(19*$a+$b-$d-$g+15)%30;
  $i=floor($c/4);
  $k=$c%4;
  $l=(32+2*$e+2*$i-$h-$k)%7;
  $m=floor(($a+11*$h+22*$l)/451);
  $n=$h+$l-7*$m+114;

  $EasterMonth = floor($n/31);
  $EasterDay   = $n%31+1;
  $Offset = mktime(0,0,0,$EasterMonth,$EasterDay+$OffsetDays,$Year);

  $OffsetDate['Day']   = date("j",$Offset);  //Day   1-31
  $OffsetDate['Month'] = date("n",$Offset);  //Month 1-12
  $OffsetDate['Year']  = date("Y",$Offset);

  return ($OffsetDate);
 }
}

/****************************************************************************
CreateScriptByName,
  Script ueber 

ReleaseNotes:
xx.05.2013 tgusi74
 + Funktion erstellt
*****************************************************************************/
function CreateScriptByName($ScriptNAME, $ParentID, $ScriptTEXT)
{
    global $_IPS;
    $ScriptID = @IPS_GetScriptIDByName($ScriptNAME, $ParentID);
    if ($ScriptID == 0)
       {
        $ScriptID = IPS_CreateScript(0);
        IPS_SetName($ScriptID, $ScriptNAME);
        IPS_SetParent($ScriptID, $ParentID);
        IPS_SetInfo($ScriptID, "This script was created by: #". $_IPS['SELF'] ."#");
        
        $fh = fopen(IPS_GetKernelDir()."scripts\\".$ScriptID.".ips.php", 'w') or die("can't open file");
        fwrite($fh, $ScriptTEXT);
        fclose($fh);
        $ScriptPath = $ScriptID.".ips.php";     //Skriptdatei
        IPS_SetScriptFile($ScriptID, $ScriptPath);
        IPS_SetHidden($ScriptID, true);
       // echo "Die Skript-ID lautet: ". $ScriptID;
      }
}


/****************************************************************************
GetValueByName,
  liest die Variable des Variableenstring aus

  + Als Trennstrich wird ein Schrägstrich verwendet "/"
        sollte jedoch der Aufruf mit Backslash "\" passieren
        wird dieser automatisch konveriert

Example:  $Wert = GetValueByName("AAA/BBB/CCC/DDD/TESTVAR1");

ReleaseNotes:
01.05.2009 Gusenbauer
 + Function erstellt und geprüft
15.05.2009 Gusenbauer
 + Relativer Pfad erweitert um
     - /   ==> Ebene unterhalb des Scriptes
     - ./  ==> Ebene wie Script
     - ../ ==> Ebene oberhalb des Scriptes
*****************************************************************************/

function GetValueByName($Name)
{
  $NewID = 0; //RootID
  $Name = str_replace(chr(92),"/",$Name);
  $msgtxt ="";

  if (substr($Name,0,1) == "/")
     {
      //Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene unterhalb einordnen (Ebene unterhalb des Scriptes)
      global $_IPS;
      $NewID = $_IPS['SELF'];
      $Name = substr($Name,1);
      $msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - /";
     }

  if (substr($Name,0,2) == "./")
     {
      //Uebergabepfad ist RELATIVER PFAD ==> Hierachie wie Script (Scriptebene)
      global $_IPS;
      $ObjectInfo = IPS_GetObject($_IPS['SELF']);
      $NewID = $ObjectInfo['ParentID'];
      $Name = substr($Name,2);
      $msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ./";
     }

  if (substr($Name,0,3) == "../")
     {
      //Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene höher einordnen (Ebene über Script)
      global $_IPS;
      $ObjectInfo = IPS_GetObject($_IPS['SELF']);
      $ObjectInfo = IPS_GetObject($ObjectInfo['ParentID']);
      $NewID = $ObjectInfo['ParentID'];
      $Name = substr($Name,3);
      $msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ../";
     }

  foreach (explode("/", $Name) as $NameTag)
     {
      $PrevID = $NewID;
      $NewID = @IPS_GetObjectIDByName($NameTag,$PrevID);
      if (@IPS_GetName($NewID) != $NameTag)
         {
          echo "FEHLER: Pfad / Variable '" . $NameTag ."' existiert nicht !!(" . $msgtxt . $Name . ")\r\n";
          return false;
          break;
         }
     }

  if ($NameTag != "")
     {
      if (@IPS_GetVariableIDByName($NameTag,$PrevID) >= 1)
         {
          //Wert von der Variable lesen und zureuckgeben
          return GetValue($NewID);
         }
      else
         {
          echo "FEHLER: Variable '" . $NameTag . "' existiert nicht !!! (" . $msgtxt . $Name . ")\r\n";
          return false;
         }
     }
  else
     {
      echo "FEHLER: als VARIABLENNAME konnte nur ein Leerstring ermittel werden !!! (" . $msgtxt . $Name . ")\r\n";
      return false;
     }
}


/****************************************************************************
GetVariableByName,
  liest die Variable des Variableenstring aus und gibt ein INFO-Array zurück

  + Als Trennstrich wird ein Schrägstrich verwendet "/"
        sollte jedoch der Aufruf mit Backslash "\" passieren
        wird dieser automatisch konveriert

Example:  $VarInfoArray = GetVariableByName("AAA/BBB/CCC/DDD/TESTVAR_ABSOLUT_PFAD");

          echo $VarInfoArray['ID'] . "\r\n";
          echo $VarInfoArray['NAME'] . "\r\n";
          echo $VarInfoArray['VALUE'] . "\r\n";
          echo $VarInfoArray['TS_UPDATE'] . "\r\n";
          echo $VarInfoArray['TS_CHANGE'] . "\r\n";
          echo $VarInfoArray['TS_UPDATE_UNIX'] . "\r\n";
          echo $VarInfoArray['TS_CHANGE_UNIX'] . "\r\n";

          erzeugt folgende Ausgabe
             45226
          TESTVAR_ABSOLUT_PFAD
          1
          15.05.2009 23:34:43
          15.05.2009 21:42:56
          1242423283.093
          1242416576.109

ReleaseNotes:
15.05.2009 Gusenbauer
 + Funktion erstellt
*****************************************************************************/

function GetVariableByName($VaribalenPathName)
  {
    $VaribalenID = @CheckObjektHierachie($VaribalenPathName);
    $VARINFO_ARRAY = array();

    if($VaribalenID >= 1)
      {
       $VariablenID_INFO = @IPS_GetObject($VaribalenID);
       if ($VariablenID_INFO['ObjectType'] == 2) //Check ob Objekt eine Variable ist
          {
           $VarInfo = @IPS_GetVariable($VaribalenID);

           $VARINFO_ARRAY['ID']              = $VariablenID_INFO['ObjectID'];
           $VARINFO_ARRAY['NAME']            = $VariablenID_INFO['ObjectName'];
           $VARINFO_ARRAY['VALUE']           = GetValue($VaribalenID);
           $VARINFO_ARRAY['TS_UPDATE']       = date("d.m.Y H:i:s", $VarInfo['VariableUpdated']);
           $VARINFO_ARRAY['TS_CHANGE']       = date("d.m.Y H:i:s", $VarInfo['VariableChanged']);
           $VARINFO_ARRAY['TS_UPDATE_UNIX']  = $VarInfo['VariableUpdated'];
           $VARINFO_ARRAY['TS_CHANGE_UNIX']  = $VarInfo['VariableChanged'];
          }
      }
    else
      {
        exit("FEHLER: Variable : '" . $VaribalenPathName ."' ist nicht in IPS vorhanden !!\r\n");
      }

   return $VARINFO_ARRAY;
  }


/****************************************************************************
GetValueFormattedByName,
  liest die Variable des Variableenstring aus und gibt den formatierten Wert
  zurück, ist kein Varibalenprofil aktiv wird der unformtierte Wert zurückgegeben
  (dieser unformatierte wert wird als String konvertiert)
   ==> "" wird als "0" zurückgegeben !!!

  + Als Trennstrich wird ein Schrägstrich verwendet "/"
        sollte jedoch der Aufruf mit Backslash "\" passieren
        wird dieser automatisch konveriert

Example:  $Wert = GetValueFormattedByName("AAA/BBB/CCC/DDD/TESTVAR1");

ReleaseNotes:
01.09.2009 Gusenbauer
 + Function erstellt und geprüft
*****************************************************************************/

function GetValueFormattedByName($Name)
{
  $NewID = 0; //RootID
  $Name = str_replace(chr(92),"/",$Name);
  $msgtxt ="";

  if (substr($Name,0,1) == "/")
     {
      //Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene unterhalb einordnen (Ebene unterhalb des Scriptes)
      global $_IPS;
      $NewID = $_IPS['SELF'];
      $Name = substr($Name,1);
      $msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - /";
     }

  if (substr($Name,0,2) == "./")
     {
      //Uebergabepfad ist RELATIVER PFAD ==> Hierachie wie Script (Scriptebene)
      global $_IPS;
      $ObjectInfo = IPS_GetObject($_IPS['SELF']);
      $NewID = $ObjectInfo['ParentID'];
      $Name = substr($Name,2);
      $msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ./";
     }

  if (substr($Name,0,3) == "../")
     {
      //Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene höher einordnen (Ebene über Script)
      global $_IPS;
      $ObjectInfo = IPS_GetObject($_IPS['SELF']);
      $ObjectInfo = IPS_GetObject($ObjectInfo['ParentID']);
      $NewID = $ObjectInfo['ParentID'];
      $Name = substr($Name,3);
      $msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ../";
     }

  foreach (explode("/", $Name) as $NameTag)
     {
      $PrevID = $NewID;
      $NewID = @IPS_GetObjectIDByName($NameTag,$PrevID);
      if (@IPS_GetName($NewID) != $NameTag)
         {
          echo "FEHLER: Pfad / Variable '" . $NameTag ."' existiert nicht !!(" . $msgtxt . $Name . ")\r\n";
          return false;
          break;
         }
     }

  if ($NameTag != "")
     {
      if (@IPS_GetVariableIDByName($NameTag,$PrevID) >= 1)
         {
          if(@GetValueFormatted($NewID) != "")
            {
             //Formatierten Wert zurückgeben
             return @GetValueFormatted($NewID);
            }
          else
            {
             if (GetValue($NewID) == "")
                {
                 return "0";
                }
             else
                {
                 //Wert von der Variable lesen und zureuckgeben
                 return (string)GetValue($NewID);
                }
            }
         }
      else
         {
          echo "FEHLER: Variable '" . $NameTag . "' existiert nicht !!! (" . $msgtxt . $Name . ")\r\n";
          return false;
         }
     }
  else
     {
      echo "FEHLER: als VARIABLENNAME konnte nur ein Leerstring ermittel werden !!! (" . $msgtxt . $Name . ")\r\n";
      return false;
     }
}


/****************************************************************************
CheckCreateVariable,
  prüft ob eine Variable in der Objekthierachie existiert bzw. erzeugt diese

  + Achtung:, es wird nur die Variable generiert jedoch nicht Kategorgieebene
                  bzw. Objekthierachien
               ... dies bitte zuvor mit CheckCreateCategory("AAA/BBB/CCC/DDD") oder
                      von Hand erzeugen

  + Als Trennstrich wird ein Schrägstrich verwendet "/"
        sollte jedoch der Aufruf mit Backslash "\" passieren
        wird dieser automatisch konveriert

Example:  CheckCreateVariable("AAA/BBB/CCC/DDD/TESTVAR1",1,20);
                ... wurde eine Variable "TESTVAR1" erzeugen wenn nicht existiert
                ... die Variable wird als INTEGER angelegt
                ... Defaultwert wird auf 20 gesetzt

VariableTyp: 0=boolean / 1=integer / 2=float / 3=string

ReleaseNotes:
02.04.2009 Gusenbauer
 + Function erstellt und geprüft
01.05.2009 Gusenbauer
 + Moeglichkeit einen REALTIVEN PFAD zu uebergeben, wird aber hier schon durch
   CheckObjektHierachie erledigt ==> nur getestet
04.05.2009 Gusenbauer
 + IPS-Funktionen mit @Funktionsname aufrufen
 + Ausgabe des Varibalentyp bei Anlage
 + Defaultwert ist Wert ungleich ""
15.05.2009 Gusenbauer
 + Hilfstexte wegen relativer Pfaderweiterung angepasst
     - /   ==> Ebene unterhalb des Scriptes
     - ./  ==> Ebene wie Script
     - ../ ==> Ebene oberhalb des Scriptes
31.07.2009 Gusenbauer
 + Schreibfehler behoben ($VariableString) ==> WARNINGS in IPS2.1
09.09.2009 Gusenbauer
 + Funktionserweiterung um VariablenProfil, VariablenProfilActionScript und VariablenInfoText
*****************************************************************************/
function CheckCreateVariable($VariablenString,$VariableTyp=1,$VariableDefaultValue="",$VariablenProfil="",$VariablenProfilActionScript="",$VariablenInfoText="")
{
  $NewID = 0; //RootID
  $VariablenString = str_replace(chr(92),"/",$VariablenString);
  $msgtxt ="";
  global $_IPS;

  if (substr($VariablenString,0,1) == "/")
     {
      //Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene unterhalb einordnen (Ebene unterhalb des Scriptes)
      global $_IPS;
      $msgtxt = $_IPS['SELF'] . " - " . IPS_GetName($_IPS['SELF']) ." - ";
     }

  if (substr($VariablenString,0,2) == "./")
     {
      //Uebergabepfad ist RELATIVER PFAD ==> Hierachie wie Script (Scriptebene)
      global $_IPS;
      $ObjectInfo = IPS_GetObject($_IPS['SELF']);
      $msgtxt = $ObjectInfo['ParentID'] . " - " . IPS_GetName($ObjectInfo['ParentID']) ." - ";
     }

  if (substr($VariablenString,0,3) == "../")
     {
      //Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene höher einordnen (Ebene über Script)
      global $_IPS;
      $ObjectInfo = IPS_GetObject($_IPS['SELF']);
      $ObjectInfo = IPS_GetObject($ObjectInfo['ParentID']);
      $msgtxt = $ObjectInfo['ParentID'] . " - " . IPS_GetName($ObjectInfo['ParentID']) ." - ";
     }


  //Check ob sich die Variable in einer Objekthierachie befinden soll
  if (strrpos($VariablenString, "/") !== false)
     {
      $PathString = substr($VariablenString,0,strrpos($VariablenString, "/")+1);
      $ret = CheckObjektHierachie($PathString);

      if ($ret <= 0)
         {
          echo("FEHLER: Objektebenenpfad '" . $PathString . "' existiert nicht !!! \r\n");
          return false;
         }
      else
         {
          $NewID = $ret;
         }
     }

  $VarString = substr($VariablenString,strlen($PathString));
  $VarID = @IPS_GetVariableIDByName($VarString,$NewID);
  if ($VarID <= 0)
     {
      if (!isset($VariableTyp))
         {
          $VariableTyp = 1;
         }

      switch ($VariableTyp)
         {
          case 0:
                 $VarID = IPS_CreateVariable(0);
                 $msg_VARTEXT = "als BOOLEAN";
                 break;
          case 1:
                 $VarID = IPS_CreateVariable(1);
                 $msg_VARTEXT = "als INTEGER";
                 break;
          case 2:
                 $VarID = IPS_CreateVariable(2);
                 $msg_VARTEXT = "als FLOAT";
                 break;
          case 3:
                 $VarID = IPS_CreateVariable(3);
                 $msg_VARTEXT = "als STRING";
                 break;
          default:
                 $VarID = IPS_CreateVariable(1);
                 $msg_VARTEXT = "als INTEGER (Default)";
                 break;
         }

      IPS_SetName($VarID, $VarString);
      IPS_SetParent($VarID, $NewID);
      echo ("HINWEIS: Variable ". $VarID . " - " . $VarString . " " . $msg_VARTEXT . " erzeugt");

      if ($VariableDefaultValue != "")
         {
          switch ($VariableTyp)
              {
               case 0:
                      if (is_bool($VariableDefaultValue) == true)
                         {
                          SetValueBoolean($VarID,$VariableDefaultValue);
                         }
                      break;
               case 1:
                      if (is_integer($VariableDefaultValue) == true)
                         {
                          SetValueInteger($VarID,$VariableDefaultValue);
                         }
                      break;
               case 2:
                      if (is_float($VariableDefaultValue) == true)
                         {
                          SetValueFloat($VarID,$VariableDefaultValue);
                         }
                      break;
               case 3:
                      if (is_string($VariableDefaultValue) == true)
                         {
                          SetValueString($VarID,$VariableDefaultValue);
                         }
                      break;
               default:
                      if (is_integer($VariableDefaultValue) == true)
                         {
                          SetValueInteger($VarID,$VariableDefaultValue);
                         }
                      break;
              }
          echo (" und Versuch den Defaultwert '". $VariableDefaultValue . "' zuzuweisen");
         }

      echo (" (" . $msgtxt . $VariablenString . ")\r\n");

      //09.09.2009 Gusenbauer
      if ($VariablenInfoText != "")
         {
          IPS_SetInfo($VarID,$VariablenInfoText);
          echo "HINWEIS: VariablenInfoText '" . $VariablenInfoText . "' wurde der Variable '" . $VarID . " - " . $VarString . "' zugewiesen (" . $msgtxt . $VariablenString .")\r\n";
         }
      else
         {
          IPS_SetInfo($VarID,"automatisch generierte Variable am " . date("d.m.Y H:i:s") . " vom Script '" . $_IPS['SELF'] . "-" . IPS_GetName($_IPS['SELF']) . "'");
         }

      if ($VariablenProfil != "")
         {
          if (IPS_VariableProfileExists($VariablenProfil) == true)
             {
              IPS_SetVariableCustomProfile($VarID,$VariablenProfil);
              echo "HINWEIS: VariablenProfil '" . $VariablenProfil . "' wurde der Variable '" . $VarID . " - " . $VarString . "' zugewiesen (" . $msgtxt . $VariablenString .")\r\n";
             }
          else
             {
              echo "FEHLER: VariablenProfil '" . $VariablenProfil . "' existiert nicht !! ==> keine Zuweisung zur Variable '" . $VarID . " - " . $VarString . "' durchgeführt (" . $msgtxt . $VariablenString .")\r\n";
             }
         }

      if ($VariablenProfilActionScript != "")
         {
          if (CheckScriptExistsByName($VariablenProfilActionScript) > 0)
             {
              IPS_SetVariableCustomAction($VarID,CheckScriptExistsByName($VariablenProfilActionScript));
              echo "HINWEIS: VariablenProfilActionScript '" . $VariablenProfilActionScript . "' wurde der Variable '" . $VarID . " - " . $VarString . "' zugewiesen (" . $msgtxt . $VariablenString .")\r\n";
             }
          else
             {
              echo "FEHLER: VariablenProfilActionScript '" . $VariablenProfilActionScript . "' existiert nicht !! ==> keine Zuweisung zur Variable '" . $VarID . " - " . $VarString . "' durchgeführt (" . $msgtxt . $VariablenString .")\r\n";
             }
         }
      //************************

  }
 return IPS_GetVariableIDByName($VarString,$NewID);
}


/****************************************************************************
CheckObjektHierachie,
  prüft ob die Objekthierachie existiert

  + Als Trennstrich wird ein Schrägstrich verwendet "/"
        sollte jedoch der Aufruf mit Backslash "\" passieren
        wird dieser automatisch konveriert
  + Ein Schrägstrich am Ende wird einfach ignoriert
      und stellt keine Probelm dar

Example:  CheckObjektHierachie("AAA/BBB/CCC/DDD/");

ReleaseNotes:
02.04.2009 Gusenbauer
 + Function erstellt und geprüft
01.05.2009 Gusenbauer
 + Moeglichkeit einen REALTIVEN PFAD zu uebergeben
15.05.2009 Gusenbauer
 + Relativer Pfad erweitert um
     - /   ==> Ebene unterhalb des Scriptes
     - ./  ==> Ebene wie Script
     - ../ ==> Ebene oberhalb des Scriptes
*****************************************************************************/
function CheckObjektHierachie($ObjectString)
{
  $NewID = 0; //RootID
  $ObjectString = str_replace(chr(92),"/",$ObjectString);
  $msgtxt = "";

  if (substr($ObjectString,0,1) == "/")
     {
      //Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene unterhalb einordnen (Ebene unterhalb des Scriptes)
      global $_IPS;
      $NewID = $_IPS['SELF'];
      $ObjectString = substr($ObjectString,1);
      $msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - /";
     }

  if (substr($ObjectString,0,2) == "./")
     {
      //Uebergabepfad ist RELATIVER PFAD ==> Hierachie wie Script (Scriptebene)
      global $_IPS;
      $ObjectInfo = IPS_GetObject($_IPS['SELF']);
      $NewID = $ObjectInfo['ParentID'];
      $ObjectString = substr($ObjectString,2);
      $msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ./";
     }

  if (substr($ObjectString,0,3) == "../")
     {
      //Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene höher einordnen (Ebene über Script)
      global $_IPS;
      $ObjectInfo = IPS_GetObject($_IPS['SELF']);
      $ObjectInfo = IPS_GetObject($ObjectInfo['ParentID']);
      $NewID = $ObjectInfo['ParentID'];
      $ObjectString = substr($ObjectString,3);
      $msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ../";
     }

  foreach (explode("/", $ObjectString) as $NameTag)
     {
      if ($NameTag != "")
         {
          $PrevID = $NewID;
          $NewID = @IPS_GetObjectIDByName($NameTag,$PrevID);
          if (IPS_GetName($NewID) != $NameTag)
             {
              echo("FEHLER: Objekthierachie '" . $NameTag . "' existiert nicht !! ("  . $msgtxt . $ObjectString .")\r\n");
              break;
              return false;
             }
         }
     }
  return $NewID;
}


/****************************************************************************
CheckCreateCategory,
  prüft ob die Kategorieebene existiert bzw. erzeugt diese

  + Als Trennstrich wird ein Schrägstrich verwendet "/"
        sollte jedoch der Aufruf mit Backslash "\" passieren
        wird dieser automatisch konveriert
  + Ein Schrägstrich am Ende wird einfach ignoriert
      und stellt keine Probelm dar

Example:  CheckCreateCategory("AAA/BBB/CCC/DDD/");

ReleaseNotes:
02.04.2009 Gusenbauer
 + Function erstellt und geprüft
01.05.2009 Gusenbauer
 + Moeglichkeit einen REALTIVEN PFAD zu uebergeben
15.05.2009 Gusenbauer
 + Relativer Pfad erweitert um
     - /   ==> Ebene unterhalb des Scriptes
     - ./  ==> Ebene wie Script
     - ../ ==> Ebene oberhalb des Scriptes
*****************************************************************************/
function CheckCreateCategory($CategoryString)
{
  $NewID = 0; //RootID
  $CategaryString = str_replace(chr(92),"/",$CategoryString);
  $msgtxt = "";

  if (substr($CategoryString,0,1) == "/")
      {
       //Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene unterhalb einordnen (Ebene unterhalb des Scriptes)
       global $_IPS;
       $NewID = $_IPS['SELF'];
       $CategoryString = substr($CategoryString,1);
       $msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - /";
      }

  if (substr($CategoryString,0,2) == "./")
     {
      //Uebergabepfad ist RELATIVER PFAD ==> Hierachie wie Script (Scriptebene)
      global $_IPS;
      $ObjectInfo = IPS_GetObject($_IPS['SELF']);
      $NewID = $ObjectInfo['ParentID'];
      $CategoryString = substr($CategoryString,2);
      $msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ./";
     }

  if (substr($CategoryString,0,3) == "../")
     {
      //Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene höher einordnen (Ebene über Script)
      global $_IPS;
      $ObjectInfo = IPS_GetObject($_IPS['SELF']);
      $ObjectInfo = IPS_GetObject($ObjectInfo['ParentID']);
      $NewID = $ObjectInfo['ParentID'];
      $CategoryString = substr($CategoryString,3);
      $msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ../";
     }


  foreach (explode("/", $CategoryString) as $NameTag)
     {
      if ($NameTag != "")
         {
          $PrevID = $NewID;
          $NewID = @IPS_GetCategoryIDByName($NameTag,$PrevID);
          if (@IPS_GetName($NewID) != $NameTag)
             {
              $NewID = IPS_CreateCategory();   // Kategorie anlegen
              IPS_SetName($NewID, $NameTag);   // Kategorie benennen
              IPS_SetParent($NewID,$PrevID);   // Kategoriehirachie herstellen
              echo "HINWEIS: Neue Kategorieebene '" . $NameTag . "' erstellt (" . $msgtxt . $CategoryString .")\r\n";

              //Check ob Kategorie jetzt wirklich existiert
              $NewID = IPS_GetCategoryIDByName($NameTag,$PrevID);
              if (IPS_GetName($NewID) != $NameTag)
                 {
                  echo "FEHLER: Kategorieebene '" . $NameTag . "' konnte nicht erzeugt werden !!! (" . $msgtxt . $CategoryString .")\r\n";
                  break;
                  return false;
                 }
             }
         }
     }
  return true;
}


/****************************************************************************
CheckScriptExistsByName,
  prüft ob der Script existiert

Example:  CheckScriptExistsByName("AAA/BBB/CCC/DDD/TESTSCRIPT");

ReleaseNotes:
09.09.2009 Gusenbauer
 + Funktion erstellt
*****************************************************************************/
function CheckScriptExistsByName($ScriptString)
{
  $NewID = 0; //RootID
  $ScriptString = str_replace(chr(92),"/",$ScriptString);
  $msgtxt = "";

  if (substr($ScriptString,0,1) == "/")
      {
       //Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene unterhalb einordnen (Ebene unterhalb des Scriptes)
       global $_IPS;
       $NewID = $_IPS['SELF'];
       $ScriptString = substr($ScriptString,1);
       $msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - /";
      }

  if (substr($ScriptString,0,2) == "./")
     {
      //Uebergabepfad ist RELATIVER PFAD ==> Hierachie wie Script (Scriptebene)
      global $_IPS;
      $ObjectInfo = IPS_GetObject($_IPS['SELF']);
      $NewID = $ObjectInfo['ParentID'];
      $ScriptString = substr($ScriptString,2);
      $msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ./";
     }

  if (substr($ScriptString,0,3) == "../")
     {
      //Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene höher einordnen (Ebene über Script)
      global $_IPS;
      $ObjectInfo = IPS_GetObject($_IPS['SELF']);
      $ObjectInfo = IPS_GetObject($ObjectInfo['ParentID']);
      $NewID = $ObjectInfo['ParentID'];
      $ScriptString = substr($ScriptString,3);
      $msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ../";
     }

  foreach (explode("/", $ScriptString) as $NameTag)
     {
      if ($NameTag != "")
         {
          $PrevID = $NewID;
          $NewID = @IPS_GetObjectIDByName($NameTag,$PrevID);
          if (IPS_GetName($NewID) != $NameTag)
             {
              echo("FEHLER: Objekthierachie '" . $NameTag . "' existiert nicht !! ("  . $msgtxt . $ObjectString .")\r\n");
              break;
              return false;
             }
         }
      }

   $ObjectInfo = @IPS_GetObject($NewID);
   if ($ObjectInfo['ObjectType'] == 3) // 3 = ist ein Script
      {
       return $NewID;
      }
   else
      {
       return false;
      }

}


/****************************************************************************
SetValueBooleanByName,
SetValueIntegerByName,
SetValueFloatByName,
SetValueStringByName,
  schreibt auf die Variableenstring den Uebergabewert

  + Als Trennstrich wird ein Schrägstrich verwendet "/"
        sollte jedoch der Aufruf mit Backslash "\" passieren
        wird dieser automatisch konveriert

Example:  SetValueBooleanByName("AAA/BBB/CCC/DDD/TESTVAR1",TRUE);
          SetValueIntegerByName("AAA/BBB/CCC/DDD/TESTVAR1",1234);
          SetValueFloatByName("AAA/BBB/CCC/DDD/TESTVAR1",23.67e-2);
          SetValueStringByName("AAA/BBB/CCC/DDD/TESTVAR1","Das ist ein Test");

ReleaseNotes:
04.05.2009 Gusenbauer
 + Code nach _SetValueByName ausgelagert
*****************************************************************************/
function SetValueBooleanByName($Name,$Value)
 {
  return _SetValueByName(0,0,$Name,$Value);
 }

function SetValueIntegerByName($Name,$Value)
 {
  return _SetValueByName(1,0,$Name,$Value);
 }

function SetValueFloatByName($Name,$Value)
 {
  return _SetValueByName(2,0,$Name,$Value);
 }

function SetValueStringByName($Name,$Value)
 {
  return _SetValueByName(3,0,$Name,$Value);
 }


/****************************************************************************
SetValueBooleanByNameCC,
SetValueIntegerByNameCC,
SetValueFloatByNameCC,
SetValueStringByNameCC,
  schreibt auf die Variableenstring den Uebergabewert und erzeugt fehlende
  Objekthierachien mit Kategorieebenen und erzeugt auch die Variable

  + Als Trennstrich wird ein Schrägstrich verwendet "/"
        sollte jedoch der Aufruf mit Backslash "\" passieren
        wird dieser automatisch konveriert

Example:  SetValueBooleanByNameCC("AAA/BBB/CCC/DDD/TESTVAR1",TRUE);
          SetValueIntegerByNameCC("AAA/BBB/CCC/DDD/TESTVAR1",1234);
          SetValueFloatByNameCC("AAA/BBB/CCC/DDD/TESTVAR1",23.67e-2);
          SetValueStringByNameCC("AAA/BBB/CCC/DDD/TESTVAR1","Das ist ein Test");

ReleaseNotes:
05.05.2009 Gusenbauer
 + Funktionen erstellt
09.09.2009 Gusenbauer
 + Erweiterung um VaribalenProfil, VariablenActionScript und VariablenInfo

*****************************************************************************/
function SetValueBooleanByNameCC($Name,$Value,$VarProfil="",$VarProfilActionScript="",$VarInfoText="")
 {
  return _SetValueByName(0,1,$Name,$Value,$VarProfil,$VarProfilActionScript,$VarInfoText);
 }

function SetValueIntegerByNameCC($Name,$Value,$VarProfil="",$VarProfilActionScript="",$VarInfoText="")
 {
  return _SetValueByName(1,1,$Name,$Value,$VarProfil,$VarProfilActionScript,$VarInfoText);
 }

function SetValueFloatByNameCC($Name,$Value,$VarProfil="",$VarProfilActionScript="",$VarInfoText="")
 {
  return _SetValueByName(2,1,$Name,$Value,$VarProfil,$VarProfilActionScript,$VarInfoText);
 }

function SetValueStringByNameCC($Name,$Value,$VarProfil="",$VarProfilActionScript="",$VarInfoText="")
 {
  return _SetValueByName(3,1,$Name,$Value,$VarProfil,$VarProfilActionScript,$VarInfoText);
 }


/****************************************************************************
ConvertToBoolean,
  konvertiert den Übergabewert in Boolaen (Default = FALSE) !!

Example:  ConvertToBoolean(1);

ReleaseNotes:
02.04.2009 Gusenbauer
 + Check ob Übergabewert einen STRING entspricht
*****************************************************************************/
function ConvertToBoolean($Value)
 {
     $Value = strtoupper($Value);

     if (in_array($Value,array('TRUE', 'YES', 'Y', '1', 'ON', 'EIN', 'J', 'JA', true, 1), true))
        {
         return true;
        }
     else
        {
         return false;
        }
 }


/****************************************************************************
GetAllVariablesOfObjectHierachieForVisual,
  holt alle Varibalen der Objekthierachie von IPS und bau ein INFO-ARRAY !!

Example:  $VARIDs = GetAllVariablesOfObjectHierachieForVisual("S7/PALETTENNUMMERN/");
          while($ID = each($VARIDs))
            {
             print("<H6>VariableID: " . $ID[1]['ID']. " - " . $ID[1]['NAME']
                      ." - Wert = " . $ID[1]['VALUE']
                      ."(letzter Werte change = " . $ID[1]['TS_CHANGE']
                      ." letztes Update = " . $ID[1]['TS_UPDATE'] .")</H6>");
            }

ReleaseNotes:
03.04.2009 Gusenbauer
 + Einfuehrung der Function
*****************************************************************************/
function GetAllVariablesOfObjectHierachieForVisual($VaribalenPath)
  {

    $VaribalenPathID = @CheckObjektHierachie($VaribalenPath);
    $VARINFO_ARRAY = array();

    if($VaribalenPathID >= 1)
      {
       $PathChilds = @IPS_GetChildrenIDs($VaribalenPathID);

       foreach ($PathChilds as $ChildID)
             {
              $ChildIDINFO = @IPS_GetObject($ChildID);
              if ($ChildIDINFO['ObjectType'] == 2) //Check ob Objekt eine Variable ist
                 {
                  $VarInfo = @IPS_GetVariable($ChildID);

                  $VARINFO_ARRAY[$ChildIDINFO['ObjectName']]['ID']         = $ChildIDINFO['ObjectID'];
                  $VARINFO_ARRAY[$ChildIDINFO['ObjectName']]['NAME']       = $ChildIDINFO['ObjectName'];
                  $VARINFO_ARRAY[$ChildIDINFO['ObjectName']]['VALUE']      = GetValue($ChildID);
                  $VARINFO_ARRAY[$ChildIDINFO['ObjectName']]['TS_UPDATE']  = date("d.m.Y H:i:s", $VarInfo['VariableUpdated']);
                  $VARINFO_ARRAY[$ChildIDINFO['ObjectName']]['TS_CHANGE']  = date("d.m.Y H:i:s", $VarInfo['VariableChanged']);
                  $VARINFO_ARRAY[$ChildIDINFO['ObjectName']]['TS_UPDATE_UNIX']  = $VarInfo['VariableUpdated'];
                  $VARINFO_ARRAY[$ChildIDINFO['ObjectName']]['TS_CHANGE_UNIX']  = $VarInfo['VariableChanged'];
                 }
             }
      }
    else
      {
        exit("FEHLER: Objectpath : '" . $VaribalenPath ."' ist nicht in IPS vorhanden !!\r\n");
      }

   return $VARINFO_ARRAY;
  }


/****************************************************************************
INTERNE FUNCTIONEN NICHT FUER DEN EXTERNEN AUFRUF GEEIGNET
*****************************************************************************/

/****************************************************************************
_SetValueByName,
  schreibt auf die Variableenstring den Uebergabewert

  + Als Trennstrich wird ein Schrägstrich verwendet "/"
        sollte jedoch der Aufruf mit Backslash "\" passieren
        wird dieser automatisch konveriert

Example:  _SetValueByName(3,1,"AAA/BBB/CCC/DDD/TESTVAR1","Das ist ein Test");

VariablenTyp: 0=boolean / 1=integer / 2=float / 3=string
CheckCreate:  0= Objekthierachie und Variable muss existieren
                  1= Fehlende Objektebenen werden als Kategorieelemente gefuellt
                     und die Variable wird erzeugt
ReleaseNotes:
04.05.2009 Gusenbauer
 + Funktion fuer alle SetValue*ByName eine globale Funktion gebaut
      - alte ReleaseNotes der Funktionen
29.03.2009 Gusenbauer
 + Function erstellt und geprüft
02.04.2009 Gusenbauer
 + Check ob "letzter Teilstring" wirklich eine VARIABLE ist
01.05.2009 Gusenbauer
 + Moeglichkeit einen REALTIVEN PFAD zu uebergeben
05.05.2009 Gusenbauer
 + Funktion um CHECK AND CREATE erweitert, weil dadurch nur
   mehr eine Funktionaufruf in den Scripten erfolgen muss und der Ablauf optimiert ist
15.05.2009 Gusenbauer
 + Relativer Pfad erweitert um
     - /   ==> Ebene unterhalb des Scriptes
     - ./  ==> Ebene wie Script
     - ../ ==> Ebene oberhalb des Scriptes
13.07.2009 Gusenbauer
 + BUGFIX --> bei relativen Pfad Variable "$PathString" initialisieren, hat zu
    "Warnings" in IPS2.1 Beta gefuehrt ==> wegen error_reporting=E_ALL
09.09.2009 Gusenbauer
 + Erweiterung um VariablenProfil und VariablenProfilActionScript
21.04.2010 Gusenbauer
 + IPS_SELF mit global uebergeben
15.05.2015 Gusenbauer
 + Variablen vor zuweisung sicherheitshalber gewandelz (int), (float), (string)
*****************************************************************************/
function _SetValueByName($VariablenTyp,$CheckCreate,$VariablenString,$Value,$VariablenProfil="",$VariablenProfilActionScript="",$VariablenInfoText="")
{
  global $_IPS;
  $NewID = 0; //RootID
  $VariablenString = str_replace(chr(92),"/",$VariablenString);

  $msgtxt = "";
  $msgtxt_function = "";


  if (substr($VariablenString,0,1) == "/")
     {
      //Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene unterhalb einordnen (Ebene unterhalb des Scriptes)
      global $_IPS;
      $NewID = $_IPS['SELF'];
      $VariablenString = substr($VariablenString,1);
      $PathString = "";
      $msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - /";
     }

  if (substr($VariablenString,0,2) == "./")
     {
      //Uebergabepfad ist RELATIVER PFAD ==> Hierachie wie Script (Scriptebene)
      global $_IPS;
      $ObjectInfo = IPS_GetObject($_IPS['SELF']);
      $NewID = $ObjectInfo['ParentID'];
      $VariablenString = substr($VariablenString,2);
      $PathString = "";
      $msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ./";
     }

  if (substr($VariablenString,0,3) == "../")
     {
      //Uebergabepfad ist RELATIVER PFAD ==> Hierachie 1 Ebene höher einordnen (Ebene über Script)
      global $_IPS;
      $ObjectInfo = IPS_GetObject($_IPS['SELF']);
      $ObjectInfo = IPS_GetObject($ObjectInfo['ParentID']);
      $NewID = $ObjectInfo['ParentID'];
      $VariablenString = substr($VariablenString,3);
      $PathString = "";
      $msgtxt = $NewID . " - " . IPS_GetName($NewID) ." - ../";
     }


  if ($CheckCreate == 1)
     {
      //Check ob ein Element der Objektebene fehlt und noetigenfalls durch
      //ein Kategorieebenenelemt auffuellen + Variable erzeugen

      //Check ob sich die Variable in einer Objekthierachie befinden soll
      if (strrpos($VariablenString, "/") !== false)
         {
          $PathString = substr($VariablenString,0,strrpos($VariablenString, "/")+1);

          foreach (explode("/", $PathString) as $NameTag)
            {
             if ($NameTag != "")
                {
                 $PrevID = $NewID;
                 $NewID = @IPS_GetObjectIDByName($NameTag,$PrevID);
                 if (IPS_GetName($NewID) != $NameTag)
                    {
                     //Fehlendes Objekt durch Kategorieelement auffuellen
                     $NewID = IPS_CreateCategory();   // Kategorie anlegen
                     IPS_SetName($NewID, $NameTag);   // Kategorie benennen
                     IPS_SetParent($NewID,$PrevID);   // Kategoriehirachie herstellen
                     echo "HINWEIS: Neue Kategorieebene '" . $NameTag . "' erstellt (" . $msgtxt . $VariablenString .")\r\n";

                     //Check ob Kategorie jetzt wirklich existiert
                     $NewID = IPS_GetCategoryIDByName($NameTag,$PrevID);
                     if (IPS_GetName($NewID) != $NameTag)
                        {
                         echo "FEHLER: Kategorieebene '" . $NameTag . "' konnte nicht erzeugt werden !!! (" . $msgtxt . $VariablenString .")\r\n";
                         break;
                         return false;
                        }
                    }
                }
            }
         }

     $PrevID = $NewID;
     $VarString = substr($VariablenString,strlen($PathString));
     $VarID = @IPS_GetVariableIDByName($VarString,$PrevID);

     //existiert die Variable nicht
     if ($VarID <= 0)
        {
         switch ($VariablenTyp)
                {
                 case 0:
                        $VarID = IPS_CreateVariable(0);
                        $msg_VARTEXT = "als BOOLEAN";
                        break;
                 case 1:
                        $VarID = IPS_CreateVariable(1);
                        $msg_VARTEXT = "als INTEGER";
                        break;
                 case 2:
                        $VarID = IPS_CreateVariable(2);
                        $msg_VARTEXT = "als FLOAT";
                        break;
                 case 3:
                        $VarID = IPS_CreateVariable(3);
                        $msg_VARTEXT = "als STRING";
                        break;
                 default:
                        $VarID = IPS_CreateVariable(1);
                        $msg_VARTEXT = "als INTEGER (Default)";
                        break;
                }

         if (IPS_SetName($VarID, $VarString) == false)
            {
             echo "FEHLER: VariablenName '" . $VarString . "' kann nicht auf ObjektID " . $VarID . " zugewiesen werden !!! (" . $msgtxt . $VariablenString .")\r\n";
             return false;
            }

         if (IPS_SetParent($VarID, $NewID) == false)
            {
             echo "FEHLER: Variable '" . $VarID . " - " . $VarString . "' kann nicht den ParentObjekt " . $NewID . " zugewiesen werden !!! (" . $msgtxt . $VariablenString .")\r\n";
             return false;
            }

         echo "HINWEIS: Neue Variable '" . $VarID . " - " . $VarString . "' " . $msg_VARTEXT ." erzeugt (". $msgtxt . $VariablenString .")\r\n";

         //09.09.2009 Gusenbauer
         if ($VariablenInfoText != "")
            {
             IPS_SetInfo($VarID,$VariablenInfoText);
             echo "HINWEIS: VariablenInfoText '" . $VariablenInfoText . "' wurde der Variable '" . $VarID . " - " . $VarString . "' zugewiesen (" . $msgtxt . $VariablenString .")\r\n";
            }
         else
            {
             IPS_SetInfo($VarID,"automatisch generierte Variable am " . date("d.m.Y H:i:s") . " vom Script '" . $_IPS['SELF'] . "-" . IPS_GetName($_IPS['SELF']) . "'");
            }

         if ($VariablenProfil != "")
            {
             if (IPS_VariableProfileExists($VariablenProfil) == true)
                {
                 IPS_SetVariableCustomProfile($VarID,$VariablenProfil);
                 echo "HINWEIS: VariablenProfil '" . $VariablenProfil . "' wurde der Variable '" . $VarID . " - " . $VarString . "' zugewiesen (" . $msgtxt . $VariablenString .")\r\n";
                }
             else
                {
                 echo "FEHLER: VariablenProfil '" . $VariablenProfil . "' existiert nicht !! ==> keine Zuweisung zur Variable '" . $VarID . " - " . $VarString . "' durchgeführt (" . $msgtxt . $VariablenString .")\r\n";
                }
            }

         if ($VariablenProfilActionScript != "")
            {
             if (CheckScriptExistsByName($VariablenProfilActionScript) > 0)
                {
                 IPS_SetVariableCustomAction($VarID,CheckScriptExistsByName($VariablenProfilActionScript));
                 echo "HINWEIS: VariablenProfilActionScript '" . $VariablenProfilActionScript . "' wurde der Variable '" . $VarID . " - " . $VarString . "' zugewiesen (" . $msgtxt . $VariablenString .")\r\n";
                }
             else
                {
                 echo "FEHLER: VariablenProfilActionScript '" . $VariablenProfilActionScript . "' existiert nicht !! ==> keine Zuweisung zur Variable '" . $VarID . " - " . $VarString . "' durchgeführt (" . $msgtxt . $VariablenString .")\r\n";
                }
            }
         //************************

         //Wegen kompatibilitaet zur "NUR OBJEKTHIERACHIE" pruefen
         $NewID = $VarID;

        }
      else
        {
         //Wegen kompatibilitaet zur "NUR OBJEKTHIERACHIE" pruefen
         $NewID = $VarID;
        }
     }
  else
     {
      //Nur Objekthierachie pruefen
      foreach (explode("/", $VariablenString) as $VarString)
         {
          $PrevID = $NewID;
          $NewID = @IPS_GetObjectIDByName($VarString,$PrevID);
          if (@IPS_GetName($NewID) != $VarString)
             {
              echo "FEHLER: Pfad / Variable '" . $VarString ."' existiert nicht !!(" . $msgtxt . $VariablenString . ")\r\n";
              return false;
              break;
             }
         }
      }


  if ($VarString != "")
     {
      if (@IPS_GetVariableIDByName($VarString,$PrevID) >= 1)
         {
          //Wert auf VariablenID zuweisen
          switch ($VariablenTyp)
                 {
                  case 0:
                          $ret = @SetValueBoolean($NewID,ConvertToBoolean($Value));
                          $msgtxt_function = "SetValueBoolean";
                          break;
                  case 1:
                          $ret = @SetValueInteger($NewID,(int)$Value);
                          $msgtxt_function = "SetValueInteger";
                          break;
                  case 2:
                          $ret = @SetValueFloat($NewID,(float)$Value);
                          $msgtxt_function = "SetValueFloat";
                          break;
                  case 3:
                          $ret = @SetValueString($NewID,(string)$Value);
                          $msgtxt_function = "SetValueString";
                          break;
                  default:
                          echo "FEHLER: '_SETVALUEBYNAME' -  Interner Funktionsaufruf unbekannt !!\r\n";
                          $msgtxt_function = " ?????? ";
                          $ret = false;
                          break;
                 }

              //Rueckgabewert der ZUWEISFUNKTION pruefen
              if ($ret == true)
                 {
                  return true;
                 }
              else
                 {
                  echo "FEHLER: Wert '" . $Value . "' konnte mit " . $msgtxt_function ." nicht auf die ID: " . $NewID . " zuwegwiesen werden (" . $msgtxt . $VariablenString . ")\r\n";
                  return false;
                 }
         }
       else
         {
          echo "FEHLER: Variable '" . $PrevID . " - " . $VarString . "' existiert nicht !!! (" . $msgtxt . $VariablenString . ")\r\n";
          return false;
         }
     }
   else
     {
      echo "FEHLER: als VARIABLENNAME konnte nur ein Leerstring ermittel werden !!! (" . $msgtxt . $VariablenString . ")\r\n";
      return false;
     }
 }


/****************************************************************************
UUID,
- liefert einen Universally Unique IDentifier (UUID)

Sourcecode:
     * RFC 4122 (http://www.ietf.org/rfc/rfc4122.txt) defines a special type
     * of Globally Unique IDentifiers (GUID)
     *
     * @copyright  Copyright (c) CFD Labs, 2006. This function may be used
     *             freely for any purpose ; it is distributed without any
     *             form of warranty whatsoever.
     *
     * @author     David Holmes <dholmes@cfdsoftware.net>
     *
     * @return  string  A UUID, made up of 32 hex digits and 4 hyphens.

Example:     echo UUID();
Return:      {572C3801-322F-9FF4-116E-DA377082A359}

ReleaseNotes:
07.11.2009 Gusenbauer
*****************************************************************************/
function UUID()
 {
   // The field names refer to RFC 4122 section 4.1.2

   return sprintf(chr(123) . strtoupper('%04x%04x-%04x-%03x4-%04x-%04x%04x%04x'). chr(125),
       mt_rand(0, 65535), mt_rand(0, 65535), // 32 bits for "time_low"
       mt_rand(0, 65535), // 16 bits for "time_mid"
       mt_rand(0, 4095),  // 12 bits before the 0100 of (version) 4 for "time_hi_and_version"
       bindec(substr_replace(sprintf('%016b', mt_rand(0, 65535)), '01', 6, 2)),
           // 8 bits, the last two of which (positions 6 and 7) are 01, for "clk_seq_hi_res"
           // (hence, the 2nd hex digit after the 3rd hyphen can only be 1, 5, 9 or d)
           // 8 bits for "clk_seq_low"
       mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535) // 48 bits for "node"
   );
 }


/****************************************************************************
GUID,
- liefert einen Globally Unique IDentifier (GUID)

Sourcecode:  http://php.net/manual/en/function.com-create-guid.php
Example:     echo GUID();
Return:      {451EB352-B8E9-49A7-B864-AE5112CA2FB2}

ReleaseNotes:
07.11.2009 Gusenbauer
*****************************************************************************/
function GUID()
 {
  if (function_exists('com_create_guid'))
     {
      return com_create_guid();
     }
  else
     {
      mt_srand((double)microtime()*10000);//optional for php 4.2.0 and up.
      $charid = strtoupper(md5(uniqid(rand(), true)));
      $hyphen = chr(45);// "-"
      $uuid = chr(123)// "{"
              .substr($charid, 0, 8).$hyphen
              .substr($charid, 8, 4).$hyphen
              .substr($charid,12, 4).$hyphen
              .substr($charid,16, 4).$hyphen
              .substr($charid,20,12)
              .chr(125);// "}"
      return $uuid;
    }
 }

/****************************************************************************
ENDE
*****************************************************************************/
?>